// Celadon's unique dust effects
addHook("MobjSpawn",function(mo)

	// Since spinobjects contain no references to the player that spawned them, assume any Celadon you may be touching did
	searchBlockmap("objects",function(r,f)
		if f.player
		and f.skin == "celadon"
		and R_PointToDist2(r.x,r.y,f.x,f.y) <= f.radius + r.radius
		and not (r.target and r.target.valid and R_PointToDist2(r.x,r.y,f.x,f.y) >= R_PointToDist2(r.x,r.y,r.target.x,r.target.y)) // If you're touching multiple Celadons, pick the nearest
			r.target = f
		end
	end,mo)
	
	// All that just to copy a few things from the player that spawned you
	if mo.target and mo.target.valid and P_IsObjectOnGround(mo.target)
		mo.scale = mo.target.scale
		mo.eflags = mo.target.eflags
	end
	
	// Generate a random vector
	local vec = {
		x = P_RandomRange(-10,10) * mo.scale / 3,
		y = P_RandomRange(-10,10) * mo.scale / 3,
		z = P_RandomRange(0,20) * mo.scale / 3 // Adjust the range on the Z axis to make sure it travels up...
	}
	
	// ...or down, as needed
	if mo.eflags & MFE_VERTICALFLIP
		vec.z = -$
	end
	
	// Set velocity according to that vector
	mo.momx = vec.x
	mo.momy = vec.y
	mo.momz = vec.z

	mo.alpha = FU / 2 // Transparent
	mo.scale = P_RandomRange(5,20) * $ / 5 // Get big or don't
	mo.destscale = mo.scale * 2 // Get even bigger over time
end,MT_CELADUST)

// Don't make Spindash particles when crouching
local nospinparticle = function(mo)
	// Once again, no pointer to the one that spawned you, so just look for it yourself
	searchBlockmap("objects",function(r,f)
		if f.player
		and f.skin == "celadon"
		and R_PointToDist2(r.x,r.y,f.x,f.y) < f.radius + r.radius
			// Don't spawn
			mo.state = S_NULL
			return true
		end
	end,mo)
end

addHook("MobjSpawn",nospinparticle,MT_SPINDUST)
addHook("MobjSpawn",nospinparticle,MT_SPLISH)

// Object weights for the Psycho Stomp
addHook("MobjSpawn",function(mo)
	// Heavy things
	if mo.type == MT_FACESTABBERSTATUE
	or mo.type == MT_BIGGARGOYLE
	or mo.type == MT_HIVEELEMENTAL 
	or mo.player
		mo.celadonweight = FU/2
		
	// Light things
	elseif mo.type == MT_BLUECRAWLA
	or mo.type == MT_REDCRAWLA
	or mo.type == MT_ROBOHOOD
		mo.celadonweight = FU*2
		
	// Brak is fat
	elseif 
		mo.type == MT_CYBRAKDEMON
	end
end)